import java.io.IOException; 
import java.util.Vector; 
import java.util.Enumeration; 
import javax.media.*; 
import javax.media.format.*; 
import javax.media.protocol.*; 
import javax.media.datasink.*; 
import javax.media.control.MonitorControl;
import javax.swing.JOptionPane;
import javax.swing.ProgressMonitor;
import java.awt.*;
import java.net.URL;

    
public class DataSourceReader implements ControllerListener, DataSinkListener {

	//fields
    Processor p;
    Object waitSync = new Object();
    boolean  stateTransitionOK = true;
    Vector audioStream = new Vector();
    public boolean openAllRightFlag = false;
    double duration;
    public String dstype;
    boolean error = false;
    int samplerate = 0;
    int begin = 0;
    int end = 0;
	public Vector v  = new Vector ();
    
    //constructor
    public DataSourceReader(int b, int e){
	    begin = b;
	    end = e;
    }
    
    public Vector getVector(){
		return(v);
    }
    
    //open data source
    public boolean open(DataSource ds) {
	    audioStream.removeAllElements();
		dstype = ds.getContentType();
		try {
	    	p = Manager.createProcessor(ds);
		} catch (Exception e) {}
		p.addControllerListener(this);	
		p.configure();
		if (!waitForState(p.Configured)) {}
		javax.media.control.TrackControl traCont[] = p.getTrackControls();
		for (int i = 0; i < traCont.length; i++)
		{
	    	if (traCont[i].getFormat() instanceof AudioFormat) {
				AudioFormat af = (AudioFormat) traCont[i].getFormat();
				samplerate =  (int) af.getSampleRate();
				traCont[i].setFormat(new AudioFormat("LINEAR",samplerate,8,1,0,1));
				AudioFormat newaf = (AudioFormat) traCont[i].getFormat();
	    	}
		}
		p.setContentDescriptor(new ContentDescriptor(ContentDescriptor.RAW));
		p.realize();
		if (!waitForState(p.Realized)) {}
		DataSource ods = p.getDataOutput();
		DataSourceHandler handler = new DataSourceHandler();
		try {
	    	handler.setSource(ods);
		} catch (IncompatibleSourceException e) {}
		handler.addDataSinkListener(this);
		handler.start();
		p.prefetch();
		if (!waitForState(p.Prefetched)) {}
		duration = p.getDuration().getSeconds();
		p.start();
		return true;
	}

	public void addNotify() {}

    void enableSyncMux() {
		Vector muxes = PlugInManager.getPlugInList(null, null, PlugInManager.MULTIPLEXER);
		for (int i = 0; i < muxes.size(); i++) {
	    	String cname = (String)muxes.elementAt(i);
	    	if (cname.equals("com.sun.media.multiplexer.RawBufferMux")) {
				muxes.removeElementAt(i);
				break;
	    	}
		}
		PlugInManager.setPlugInList(muxes, PlugInManager.MULTIPLEXER);
    }

    boolean waitForState(int state) {
	synchronized (waitSync) {
	    try {
		while (p.getState() < state && stateTransitionOK)
		    waitSync.wait();
	    } catch (Exception e) {}
	}
		return stateTransitionOK;
    }

    public void controllerUpdate(ControllerEvent evt) {
		if (evt instanceof ConfigureCompleteEvent ||
	    	evt instanceof RealizeCompleteEvent ||
	    	evt instanceof PrefetchCompleteEvent) {
	    	synchronized (waitSync) {
				stateTransitionOK = true;
				waitSync.notifyAll();
	    	}
		} else if (evt instanceof ResourceUnavailableEvent) {
	    	synchronized (waitSync) {
				stateTransitionOK = false;
				waitSync.notifyAll();
	    	}
		} else if (evt instanceof EndOfMediaEvent) {
	    	p.close();
		} else if (evt instanceof SizeChangeEvent) {}
    }

    public void dataSinkUpdate(DataSinkEvent evt) {
		if (evt instanceof EndOfStreamEvent) {
			openAllRightFlag = true;
	    	Reader r = new Reader(audioStream);
	    	r.readerIsBack(begin, end);
	    	v = r.getVector();
	    	evt.getSourceDataSink().close();
 			if (audioStream.size() == 0){}
	    	try {
				Thread.sleep(100);
	    	} catch (Throwable t){}
		}
    }
    
    private int copyByteToIntBitwise(byte b){
		int i=0;
		if (b > 0) i = b;
		if (b < 0) {
	    	i = ~b;
	    	i += 128;
		}
		return i;
    }

    class DataSourceHandler implements DataSink, BufferTransferHandler {
		DataSource source;
		PullBufferStream pullStrms[] = null;
		PushBufferStream pushStrms[] = null;
		private Vector listeners = new Vector(1);
		SourceStream unfinishedStrms[] = null;
		Loop loops[] = null;
		Buffer readBuffer;

		public void setSource(DataSource source) throws IncompatibleSourceException {
	    	if (source instanceof PushBufferDataSource) {
				pushStrms = ((PushBufferDataSource)source).getStreams();
				unfinishedStrms = new SourceStream[pushStrms.length];
				for (int i = 0; i < pushStrms.length; i++) {
		    		pushStrms[i].setTransferHandler(this);
		    		unfinishedStrms[i] = pushStrms[i];
				}
	    	} else if (source instanceof PullBufferDataSource) {
				pullStrms = ((PullBufferDataSource)source).getStreams();
				unfinishedStrms = new SourceStream[pullStrms.length];
				loops = new Loop[pullStrms.length];
				for (int i = 0; i < pullStrms.length; i++) {
		    		loops[i] = new Loop(this, pullStrms[i]);
		    		unfinishedStrms[i] = pullStrms[i];
				}
	    	} else {
				throw new IncompatibleSourceException();
	    	}
	    	this.source = source;
	    	readBuffer = new Buffer();
		}

	public void setOutputLocator(MediaLocator ml) {}
	
	public MediaLocator getOutputLocator() {
	    return null;
	}
	
	public String getContentType() {
	    return source.getContentType();
	}

	public void open() {}
	
	public void start() {
	    try {
		source.start();
	    } catch (IOException e) {}
	    if (loops != null) {
			for (int i = 0; i < loops.length; i++){
		    	loops[i].restart();
			}
	    }
	}
	
	public void stop() {
	    try {
			source.stop();
	    } catch (IOException e) {}
	    if (loops != null) {
			for (int i = 0; i < loops.length; i++)
		    	loops[i].pause();
	    }
	}
	
	public void close() {
	    stop();
	    if (loops != null) {
			for (int i = 0; i < loops.length; i++)
		    	loops[i].kill();
	    }
	}
       	
	public void addDataSinkListener(DataSinkListener dsl) {
	    if (dsl != null)
		if (!listeners.contains(dsl))
		    listeners.addElement(dsl);
	}
	
	public void removeDataSinkListener(DataSinkListener dsl) {
	    if (dsl != null)
		listeners.removeElement(dsl);
	}
	
	protected void sendEvent(DataSinkEvent event) {
	    if (!listeners.isEmpty()) {
		    Enumeration list = listeners.elements();
		    while (list.hasMoreElements()) {
				DataSinkListener listener = (DataSinkListener)list.nextElement();
				listener.dataSinkUpdate(event);
		    }
	    }
	}

	public void transferData(PushBufferStream stream) {
	    try {
			stream.read(readBuffer);
	    } catch (IOException e) {
			sendEvent(new DataSinkErrorEvent(this, e.getMessage()));
			return;
	    }
	    printDataInfo(readBuffer);
	    if (readBuffer.isEOM() && checkDone(stream)) {
			sendEvent(new EndOfStreamEvent(this));
	    }
	}

	public boolean readPullData(PullBufferStream stream) {
	    try {
			stream.read(readBuffer);
	    } catch (IOException e) {
			return true;
	    }
	    printDataInfo(readBuffer);
	    if (readBuffer.isEOM()) {
			if (checkDone(stream))
		    	close();
			return true;
	    }
	    return false;
	}

	public boolean checkDone(SourceStream strm) {
	    boolean done = true;

	    for (int i = 0; i < unfinishedStrms.length; i++) {
			if (strm == unfinishedStrms[i])
		    	unfinishedStrms[i] = null;
			else if (unfinishedStrms[i] != null) 
		    	done = false;
	    }
	    return done;
	}

	void printDataInfo(Buffer buffer) {
	    try {
			if (buffer.getFormat() instanceof AudioFormat) {
		    	byte[] buf = (byte[]) buffer.getData();
		    	for (int i=0;i<(buffer.getLength());i++) {  
					try {
			    		audioStream.addElement (new Byte(buf[i]));
					}catch (Throwable t) {
			    		if (error == true)
						return;
			    		error = true;
					}
		    	}
		    	int pr = (int)(double)(audioStream.size() / (double)samplerate / (double)duration * 85.0);
			}
	    } catch (Exception e) {
			e.printStackTrace();
	    }
	}
	
	public Object [] getControls() {
	    return new Object[0];
	}
	
	public Object getControl(String name) {
	    return null;
	}
    }

    class Loop extends Thread {

	DataSourceHandler handler;
	PullBufferStream stream;
	boolean paused = true;
	boolean killed = false;
	
	public Loop(DataSourceHandler handler, PullBufferStream stream) {
	    this.handler = handler;
	    this.stream = stream;
	    start();
	}
	
	public  void restart() {
	    paused = false;
	    notify();
	}

	public  void pause() {
	    paused = true;
	}

	public  void kill() {
	    killed = true;
	    notify();
	}

	public void run() {
	    while (!killed) {
			try {
		    	while (paused && !killed)
					wait();
			} catch (InterruptedException e) {}

			if (!killed) {
		    	boolean done = handler.readPullData(stream);
		    	if (done)
					pause();
			}
	    }
	}
    }

    public void generateSamplesFromURL(String url) {
		String filename = "";
		try {
	    	filename = (new java.io.File ((new URL(url)).getFile()).getName());
		} catch (Throwable t) {}
		MediaLocator ml;
		if ((ml = new MediaLocator(url)) == null) {}
		DataSource ds = null;
		try {
	    	ds = Manager.createDataSource(ml);
		} catch (Exception e) {}
		if (!open(ds)){
	    	return;
		}
    }

}















