import java.util.*;
import java.io.*;
import javax.swing.*;
/**
 * This class represents the window of sonogram
 */
public class Reader {
	// length of window
    short                    timewindowlength = 0 ; 
    // length of window to transform
    byte[] timeline = new byte[2000];
    int samplestotal = 0; 
    int peakx = 0;
    // peak of time in Spec-Units
    int peaky = 0; 
    // Peak of frequency in Frequ-Diff Units;
    int samplerate = 0;                            
    String url;
    
    //some fields
    public  DataSourceReader reader;    
    public  Vector spectrum = new Vector();  
                    
    Vector audioStream = new Vector();

    // constructor
    public Reader (String file, int begin, int end)
    {
	    reader = new DataSourceReader(begin, end);
		reader.generateSamplesFromURL(file);
    }
    public Vector getVector ()
    {
		return (spectrum);
    }
    
    // constructor
    public Reader(Vector v)
    {
		audioStream = v;
    }
    public Vector getSpectrum()
    {
	    return(reader.getVector());
    }
   
    public void readerIsBack(int begin, int end){
	try {
	    double[] specbuffer = null;
	    Byte b;  
	    FastFourierTransform fft = new FastFourierTransform();
	    int transformationlength = 0;
	    spectrum.removeAllElements();
	    samplestotal = end - begin + 1;
	    timewindowlength = 512;
	  
	    double windowbuffer[] = null;	   
	    transformationlength = timewindowlength; 
 	    int winfunclen = transformationlength;
	    int overlapping = 128;
	    windowbuffer = WindowFunction.triangleWindow(winfunclen);
	    for (int i=begin;i<(end-transformationlength);i+=overlapping){
 		double timebuffer[]   = new double[transformationlength];
		for(int v=0;v<transformationlength;v++){  
		    b = (Byte)audioStream.get(v+i);
		    timebuffer[v] = b.doubleValue() * windowbuffer[v];
		}
		specbuffer = fft.doFFT(timebuffer);	               
		spectrum.addElement(specbuffer);	  
	    }
	    //normalizeSpect();
	}catch (Exception ex)
	{
		ex.printStackTrace();
	    JOptionPane.showMessageDialog(null, 
		"Can't read the file.",
		"", JOptionPane.ERROR_MESSAGE); 
	}
}                                                                     

    private void normalizeSpect(){
		double[] tempSpectrum;
		double min =   Double.MAX_VALUE;
		double max =  -Double.MAX_VALUE;
        for (int x=0;x<spectrum.size();x++)
		{
	    	tempSpectrum = (double[])spectrum.get(x);
	    	for(int y=0;y<(timewindowlength/2);y++){
				if (max<tempSpectrum[y]){
		    		max=tempSpectrum[y];
		    		peaky = y;
		    		peakx = x;
				}
				if (min > tempSpectrum[y]) 
					min=tempSpectrum[y];
	    	}
		}
       	double diff = max - min;
       	for (int x=0;x<spectrum.size();x++){
	    	tempSpectrum = (double[])spectrum.get(x);
	    	for(int y=0; y < (timewindowlength/2); y++){
				tempSpectrum[y] = (tempSpectrum[y] / diff * 255.0f);
				if (tempSpectrum[y] < 0.0f)
		    		tempSpectrum[y] = 0.0f;
				if (tempSpectrum[y] > 255.0f)
		    		tempSpectrum[y] = 255.0f;
	    	}
	    	spectrum.add(x, tempSpectrum );
		}
    }
}










