import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Line2D;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.Enumeration;
import java.io.*;
import javax.sound.sampled.*;
import java.awt.font.*;
import java.text.*;

public class RecordPlay extends JPanel implements ActionListener,ControlContext
{
    FormatControls formatControls = new FormatControls();
    SignalAnalyser signalAnalyser;
	static AudioInputStream audioInputStream;

    JButton chooseB, play_recordB, drawB_original, drawB_record, drawB_dif;
    JTextField textField;

    String fileName = "";
    String filename = "";
    File file;
    Vector aux;
    static Vector spectrum1 = new Vector();
    static Vector spectrum2 = new Vector();
    static Vector difSpectrum = new Vector();

    // constructor
	public RecordPlay() {
		// draw interface
        setLayout(new BorderLayout());
        EmptyBorder eb = new EmptyBorder(5,5,5,5);
        SoftBevelBorder sbb = new SoftBevelBorder(SoftBevelBorder.LOWERED);
        setBorder(new EmptyBorder(5,5,5,5));

        JPanel p1 = new JPanel();
        p1.setLayout(new BoxLayout(p1, BoxLayout.X_AXIS));
        p1.add(formatControls);

        JPanel p2 = new JPanel();
        p2.setBorder(sbb);
        p2.setLayout(new BoxLayout(p2, BoxLayout.Y_AXIS));

        JPanel buttonsPanel = new JPanel();
        buttonsPanel.setBorder(new EmptyBorder(10,0,5,0));
        GridLayout gridLayout = new GridLayout();
        gridLayout.setRows(2);
		gridLayout.setColumns(1);
        buttonsPanel.setLayout(gridLayout);
        
        JPanel buttonsPanel1 = new JPanel();
        chooseB = addButton("Choose File", buttonsPanel1, true);
        play_recordB = addButton("Play / Record", buttonsPanel1, false);
        
        JPanel buttonsPanel2 = new JPanel();
        drawB_original = addButton("Original FFT", buttonsPanel2, false);
        drawB_record = addButton("Record FFT", buttonsPanel2, false);
        drawB_dif = addButton("Difference FFT", buttonsPanel2, false);
        
        buttonsPanel.add(buttonsPanel1);
        buttonsPanel.add(buttonsPanel2);
        p2.add(buttonsPanel);

        JPanel savePanel = new JPanel();
        savePanel.setLayout(new BoxLayout(savePanel, BoxLayout.Y_AXIS));
     
        JPanel saveTFpanel = new JPanel();
        saveTFpanel.add(new JLabel("File to save:  "));
        saveTFpanel.add(textField = new JTextField(fileName));
        textField.setPreferredSize(new Dimension(140,25));
        savePanel.add(saveTFpanel);

        p2.add(savePanel);

        p1.add(p2);
        add(p1);
    }


    public void open() {}


    public void close() {}

	// add buttons
    private JButton addButton(String name, JPanel p, boolean state) {
        JButton b = new JButton(name);
        b.addActionListener(this);
        b.setEnabled(state);
        p.add(b);
        return b;
    }

	static public AudioFormat getFormat()
	{
		return(audioInputStream.getFormat());
	}
	
	// when click a button
    public void actionPerformed(ActionEvent e) {
        Object obj = e.getSource();
        if (obj.equals(chooseB)) {
            try {
                File file = new File(System.getProperty("user.dir"));
                JFileChooser fc = new JFileChooser(file);
                fc.setFileFilter(new javax.swing.filechooser.FileFilter () {
                    public boolean accept(File f) {
                        if (f.isDirectory()) 
                            return true;
                        if (f.getName().endsWith(".au") || f.getName().endsWith(".wav") || f.getName().endsWith(".aiff") || f.getName().endsWith(".aif"))
                            return true;
                        return false;
                    }
                    public String getDescription() {
                        return ".au, .wav, .aif, .aiff";
                    }
                });
                if (fc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
	                filename =  fc.getCurrentDirectory().toString() + 
					"/" + fc.getSelectedFile().getName();
					audioInputStream = AudioSystem.getAudioInputStream(fc.getSelectedFile());
					formatControls.setFormat(audioInputStream.getFormat());
                    drawB_original.setEnabled(true);
                    play_recordB.setEnabled(true);
                }
            } catch (SecurityException ex) { 
                ex.printStackTrace();
            } catch (Exception ex) { 
                ex.printStackTrace();
            }
        }else if (obj.equals(play_recordB)) {
	        if(textField.getText().trim().compareTo("") == 0){
	        	JOptionPane.showMessageDialog(null, 
		    	"Please enter the record file name.",
		    	"", JOptionPane.ERROR_MESSAGE); 
		    }
		    else{
	        	File dir = new File (".");
		    	fileName = "";
		    	try {
		    		fileName = dir.getCanonicalPath() + "/" + textField.getText().trim();
		    	}
				catch(Exception ex) {
	    			ex.printStackTrace();
        		}
        		if(fileName.endsWith("wav")||fileName.endsWith("aif")||fileName.endsWith("aiff")||fileName.endsWith("au")){
        		}
        		else
        			fileName += ".au";
            	SimpleAudioPlayer playAndRecord = new SimpleAudioPlayer(filename, fileName);
            	playAndRecord.play_record();
            	drawB_record.setEnabled(true);
            	drawB_dif.setEnabled(true);
        	}
        } else if (obj.equals(drawB_original)) {
	        signalAnalyser = new SignalAnalyser(this,filename);
			signalAnalyser.setSize(600,400);
			signalAnalyser.setVisible(true);
	    }else if (obj.equals(drawB_record)) {
		    File dir = new File (".");
		    fileName = "";
		    try {
		    	fileName = dir.getCanonicalPath() + "/" + textField.getText().trim();
		    }
			catch(Exception ex) {
	    		ex.printStackTrace();
        	}
        	if(fileName.endsWith("wav")||fileName.endsWith("aif")||fileName.endsWith("aiff")||fileName.endsWith("au")){
        	}
        	else
        		fileName += ".au";
	        signalAnalyser = new SignalAnalyser(this, fileName);
			signalAnalyser.setSize(600,400);
			signalAnalyser.setVisible(true);
	    }else if (obj.equals(drawB_dif)) {
		    File dir = new File (".");
		    String fileName = "";
		    try {
		    	fileName = dir.getCanonicalPath() + "/" + textField.getText().trim();
		    }
			catch(Exception ex) {
	    		ex.printStackTrace();
        	}
        	double[] tempSpectrum1;
			double[] tempSpectrum2;
			for (int i = 0 ; i < spectrum2.size(); i++){
				tempSpectrum1 = (double[])spectrum1.get(i);
				tempSpectrum2 = (double[])spectrum2.get(i);
				double[] dif = new double[tempSpectrum1.length];
				for(int j = 0; j < tempSpectrum1.length; j++)
					dif[j] = tempSpectrum1[j] - tempSpectrum2[j];
				difSpectrum.addElement(dif);
			}
	        signalAnalyser = new SignalAnalyser(filename, fileName);
			signalAnalyser.setSize(600,400);
			signalAnalyser.setVisible(true);
    		
	    }
    }
    
    // draw interface of FormatControls panel
    class FormatControls extends JPanel {
    
        Vector groups = new Vector();
		JCheckBox linrB, ulawB, alawB, rate8B, rate11B, rate16B, rate22B, rate44B;
        JCheckBox size8B, size16B, signB, unsignB, litB, bigB, monoB,sterB;
    
        public FormatControls() {
            setLayout(new GridLayout(0,1));
            EmptyBorder eb = new EmptyBorder(0,0,0,5);
            BevelBorder bb = new BevelBorder(BevelBorder.LOWERED);
            CompoundBorder cb = new CompoundBorder(eb, bb);
            setBorder(new CompoundBorder(cb, new EmptyBorder(8,5,5,5)));
	    	JPanel pCapital = new JPanel();
	    	pCapital.setLayout(new FlowLayout());
            JPanel p1 = new JPanel();
            ButtonGroup encodingGroup = new ButtonGroup();
	    	linrB = addCheckBox(p1, encodingGroup, "linear", false);
            ulawB = addCheckBox(p1, encodingGroup, "ulaw", false);
            alawB = addCheckBox(p1, encodingGroup, "alaw", false);
	    	Font f =  new Font("", Font.BOLD, 20);
	    	JLabel capital = new JLabel("Format Control");
	    	capital.setFont(f);
	    	pCapital.add(capital);
	    	add(pCapital);
	    	JPanel pEncoding = new JPanel();
	    	pEncoding.setLayout(new FlowLayout());
	    	pEncoding.add(new JLabel("Encoding"));
	    	add(pEncoding);
            add(p1);
            groups.addElement(encodingGroup);
               
	    	JPanel pSampleRate = new JPanel();
	    	pSampleRate.setLayout(new FlowLayout());
            JPanel p2 = new JPanel();
            JPanel p2b = new JPanel();
	    	ButtonGroup sampleRateGroup = new ButtonGroup();
            rate8B = addCheckBox(p2, sampleRateGroup, "8000", false);
            rate11B = addCheckBox(p2, sampleRateGroup, "11025", false);
            rate16B = addCheckBox(p2b, sampleRateGroup, "16000", false);
            rate22B = addCheckBox(p2b, sampleRateGroup, "22050", false);
            rate44B = addCheckBox(p2b, sampleRateGroup, "44100", false);
	    	pSampleRate.add(new JLabel("Sample Rate"));
	    	add(pSampleRate);
            add(p2);
	    	add(p2b);
            groups.addElement(sampleRateGroup);
    
	    	JPanel pSampleSize = new JPanel();
	    	pSampleSize.setLayout(new FlowLayout());
            JPanel p3 = new JPanel();
            ButtonGroup sampleSizeInBitsGroup = new ButtonGroup();
            size8B = addCheckBox(p3, sampleSizeInBitsGroup, "8", false);
            size16B = addCheckBox(p3, sampleSizeInBitsGroup, "16", false);
	    	pSampleSize.add(new JLabel("Sample Size in Bits"));
	    	add(pSampleSize);
            add(p3);
            groups.addElement(sampleSizeInBitsGroup);
    
	    	JPanel pSign = new JPanel();
	    	pSign.setLayout(new FlowLayout());
            JPanel p4 = new JPanel();
            ButtonGroup signGroup = new ButtonGroup();
            signB = addCheckBox(p4, signGroup, "signed", false);
            unsignB = addCheckBox(p4, signGroup, "unsigned", false);
	    	pSign.add(new JLabel("Sign"));
	    	add(pSign);
            add(p4);
            groups.addElement(signGroup);

	    	JPanel pEndian = new JPanel();
	    	pEndian.setLayout(new FlowLayout());
            JPanel p5 = new JPanel();
            ButtonGroup endianGroup = new ButtonGroup();
            litB = addCheckBox(p5, endianGroup, "little endian", false);
            bigB = addCheckBox(p5, endianGroup, "big endian", false);
            pEndian.add(new JLabel("Endian"));
	    	add(pEndian);
	    	add(p5);
            groups.addElement(endianGroup);

	    	JPanel pChannel = new JPanel();
	    	pChannel.setLayout(new FlowLayout());
            JPanel p6 = new JPanel();
            ButtonGroup channelsGroup = new ButtonGroup();
            monoB = addCheckBox(p6, channelsGroup, "mono", false);
            sterB = addCheckBox(p6, channelsGroup, "stereo", false);
	    	pChannel.add(new JLabel("Channels"));
	    	add(pChannel);
            add(p6);
            groups.addElement(channelsGroup);
        }

		private JCheckBox addCheckBox(JPanel p, ButtonGroup g, String name, boolean state) 
        {
            JCheckBox cb = new JCheckBox(name, state);
            p.add(cb);
            g.add(cb);
            return cb;
        }

        // set audio format
        public void setFormat(AudioFormat format) {
            AudioFormat.Encoding type = format.getEncoding();
            if (type == AudioFormat.Encoding.ULAW) {
                ulawB.doClick();
            } else if (type == AudioFormat.Encoding.ALAW) {
                alawB.doClick();
            } else if (type == AudioFormat.Encoding.PCM_SIGNED) {
                linrB.doClick(); signB.doClick(); 
            } else if (type == AudioFormat.Encoding.PCM_UNSIGNED) {
                linrB.doClick(); unsignB.doClick(); 
            }
            float rate = format.getFrameRate();
            if (rate == 8000) {
                rate8B.doClick();
            } else if (rate == 11025) {
                rate11B.doClick();
            } else if (rate == 16000) {
                rate16B.doClick();
            } else if (rate == 22050) {
                rate22B.doClick();
            } else if (rate == 44100) {
                rate44B.doClick();
            }
            switch (format.getSampleSizeInBits()) {
                case 8  : size8B.doClick(); break;
                case 16 : size16B.doClick(); break;
            }
            if (format.isBigEndian()) {
                bigB.doClick(); 
            } else { 
                litB.doClick();
            }
            if (format.getChannels() == 1) {
                monoB.doClick(); 
            } else { 
                sterB.doClick();
            }
        }
    }
    
	public static Vector getVector()
	{
		return(difSpectrum);
	}
	
    public static void main(String s[]) {
        RecordPlay recordPlay = new RecordPlay();
        recordPlay.open();
        JFrame f = new JFrame("Record/Play");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) { System.exit(0); }
        });
        f.getContentPane().add("Center", recordPlay);
        f.pack();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int w = 720;
		int h = 600;
        f.setLocation(screenSize.width/2 - w/2, screenSize.height/2 - h/2);
        f.setSize(w, h);
        f.show();
    }
} 
 