import  java.io.File;
import  java.io.IOException;

import  javax.sound.sampled.AudioFormat;
import  javax.sound.sampled.AudioInputStream;
import  javax.sound.sampled.AudioSystem;
import  javax.sound.sampled.DataLine;
import  javax.sound.sampled.LineUnavailableException;
import  javax.sound.sampled.SourceDataLine;
import  javax.sound.sampled.TargetDataLine;

import  javax.sound.sampled.AudioFileFormat;

// class that plays audio
public class SimpleAudioPlayer
{
    private static final int EXTERNAL_BUFFER_SIZE = 128000;
    private File soundFile, outputFile;
    AudioFileFormat.Type targetType;

    // constructor
	public SimpleAudioPlayer(String input, String output){
		soundFile = new File(input);
		outputFile = new File(output);
		
		// create a target according to the format type
		if (output.endsWith(".wav")){
			targetType = AudioFileFormat.Type.WAVE;
		}
		else if (output.endsWith(".aif") || output.endsWith(".aiff")){
			targetType = AudioFileFormat.Type.AIFF;
		}
		else{
		 	targetType = AudioFileFormat.Type.AU;
		}
	}

    public void play_record(){
    	/* read audio file */
    	AudioInputStream audioInputStream = null;
        try{
        	audioInputStream = AudioSystem.getAudioInputStream(soundFile);
        }
        catch (Exception e){
         	e.printStackTrace();
        }

        AudioFormat audioFormat = audioInputStream.getFormat();
		AudioFormat outputaudioFormat = RecordPlay.getFormat();
        DataLine.Info   outputinfo = new DataLine.Info(TargetDataLine.class, outputaudioFormat);
		TargetDataLine  targetDataLine = null;
		try
		{
	    	targetDataLine = (TargetDataLine) AudioSystem.getLine(outputinfo);
	    	targetDataLine.open(outputaudioFormat);
		}
		catch (LineUnavailableException e)
		{
	    	System.out.println("unable to get a recording line");
	    	e.printStackTrace();
		}
		
		// create a recorder to capture sound
        SimpleAudioRecorder recorder = new SimpleAudioRecorder(targetDataLine,
			                                                   targetType,outputFile);
        SourceDataLine  line = null;
        DataLine.Info   info = new DataLine.Info(SourceDataLine.class, audioFormat);
        try
        {
            line = (SourceDataLine) AudioSystem.getLine(info);
            line.open(audioFormat);
        }
        catch (LineUnavailableException e)
        {
            e.printStackTrace();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        // begin to record
        recorder.start();
        line.start();
        int nBytesRead = 0;
        byte[]  abData = new byte[EXTERNAL_BUFFER_SIZE];
        while (nBytesRead != -1)
        {
        	try
           	{
            	nBytesRead = audioInputStream.read(abData, 0, abData.length);
            }
            catch (IOException e)
            {
                e.printStackTrace();
            }
            if (nBytesRead >= 0)
            {
            	int nBytesWritten = line.write(abData, 0, nBytesRead);
            }
        }
        line.drain();
        line.close();
        recorder.stopRecording();
	}
}

/* SimpleAudioPlayer.java */

